Bug 1662842 - glibc: realloc ncopies integer overflow [rhel-7]
Summary: glibc: realloc ncopies integer overflow [rhel-7]
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: glibc
Version: 7.6
Hardware: Unspecified
OS: Unspecified
urgent
urgent
Target Milestone: rc
: ---
Assignee: DJ Delorie
QA Contact: Sergey Kolosov
URL:
Whiteboard:
Depends On: 1662841
Blocks: 1655768 1657582
TreeView+ depends on / blocked
 
Reported: 2019-01-02 07:44 UTC by Florian Weimer
Modified: 2020-07-09 08:10 UTC (History)
8 users (show)

Fixed In Version: glibc-2.17-287.el7
Doc Type: No Doc Update
Doc Text:
Clone Of: 1662841
Environment:
Last Closed: 2019-08-06 12:49:40 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1662843 unspecified CLOSED glibc: realloc ncopies integer overflow [rhel-8] 2020-11-14 18:18:22 UTC
Red Hat Product Errata RHSA-2019:2118 None None None 2019-08-06 12:49:54 UTC
Sourceware 24027 P2 RESOLVED glibc: realloc() ncopies 32-bit integer overflow 2020-07-09 08:10:45 UTC

Internal Links: 1662843

Description Florian Weimer 2019-01-02 07:44:51 UTC
+++ This bug was initially created as a clone of Bug #1662841 +++

Under rare circumstances, the realloc implementation in glibc may not copy the entire allocation.  We need to backport this upstream commit:

commit b50dd3bc8cbb1efe85399b03d7e6c0310c2ead84
Author: Florian Weimer <fw@deneb.enyo.de>
Date:   Mon Dec 31 22:04:36 2018 +0100

    malloc: Always call memcpy in _int_realloc [BZ #24027]
    
    This commit removes the custom memcpy implementation from _int_realloc
    for small chunk sizes.  The ncopies variable has the wrong type, and
    an integer wraparound could cause the existing code to copy too few
    elements (leaving the new memory region mostly uninitialized).
    Therefore, removing this code fixes bug 24027.

Comment 8 errata-xmlrpc 2019-08-06 12:49:40 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2019:2118


Note You need to log in before you can comment on or make changes to this bug.